%define major 0
%define girmajor 0

%define libname %mklibname %{name} %{major}
%define girname %mklibname %{name}-gir %{girmajor}
%define devname %mklibname -d %{name}

# filter out private clutter/cogl .so libraries from devel requires/provides
%global __devel_exclude_path %{_libdir}/libmuffin-.*-%{major}\.so
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^devel\\(libmuffin-.*-%{major}
%define _disable_ld_no_undefined 1

Name:          muffin
Version:       6.0.0
Release:       %mkrel 1
Summary:       Window and compositing manager based on Clutter

Group:         Graphical desktop/Cinnamon
License:       GPLv2+
URL:           https://github.com/linuxmint/muffin

Source0:   https://github.com/linuxmint/muffin/archive/%{version}.tar.gz#/muffin-%{version}.tar.gz

Source1:       muffin-adwaita.txt

BuildRequires: pkgconfig(clutter-1.0) >= 1.7.5
BuildRequires: pkgconfig(sm)
BuildRequires: pkgconfig(libcanberra)
BuildRequires: pkgconfig(cinnamon-desktop) >= 5.3
BuildRequires: pkgconfig(gnome-doc-utils)
BuildRequires: pkgconfig(gobject-introspection-1.0)
BuildRequires: pkgconfig(xkeyboard-config)
BuildRequires: pkgconfig(xtst)
BuildRequires: pkgconfig(xi)
BuildRequires: pkgconfig(xcomposite) >= 0.4
BuildRequires: zenity
# Bootstrap requirements
BuildRequires: gtk-doc
BuildRequires: gnome-common
BuildRequires: intltool
BuildRequires: locales
BuildRequires: meson
BuildRequires: graphene-devel
BuildRequires: pipewire-devel
BuildRequires: cvt
BuildRequires: cmake
BuildRequires: wayland-protocols-devel
BuildRequires: x11-server-xwayland

Requires: dbus-x11
Requires: zenity

%description
Muffin is a window and compositing manager that displays and manages
your desktop via OpenGL. Muffin combines a sophisticated display engine
using the Clutter toolkit with solid window-management logic inherited
from the Metacity window manager.

While Muffin can be used stand-alone, it is primarily intended to be
used as the display core of a larger system such as Cinnamon. 
For this reason, Muffin is very extensible via plugins, which
are used both to add fancy visual effects and to rework the window
management behaviors to meet the needs of the environment.

%package -n %{libname}
Summary:        Muffin shared libraries and plugins
Group:          System/Libraries
Requires:       %{name}-schemas >= %{version}-%{release}
Conflicts:      %{_lib}muffin-gir0 < 4.8.0-2
Conflicts:      %{name} < 4.4.1-2

%description -n %{libname}
Cinnamon Desktop default window manager.
Muffin uses GTK+ and Clutter to do everything.

This package provides Muffin's shared libraries.

%package -n %{girname}
Summary:        Muffin Introspection bindings
Group:          System/Libraries
Conflicts:      %{name} < 4.4.1-2

%description -n %{girname}
Cinnamon Desktop default window manager.
Muffin uses GTK+ and Clutter to do everything.

This package provides the GObject Introspection bindings for muffin.

%package -n %{devname}
Summary: Development package for %{name}
Group: Development/GNOME and GTK+
Requires: %{name} = %{version}-%{release}
Requires: %{girname} = %{version}-%{release}
Provides: muffin-devel = %{version}-%{release}
Conflicts: %{_lib}muffin-gir0 < 4.8.0-2

%description -n %{devname}
Header files and libraries for developing Muffin plugins. Also includes
utilities for testing Metacity/Muffin themes.

%package schemas
Summary: GSettings schemas for %{name}
Group: Graphical desktop/Cinnamon
BuildArch: noarch
Conflicts: %{_lib}muffin-gir0 < 4.8.0-2
Conflicts: %{name} < 4.4.1-4

%description schemas
This package contains GSettings schemas for %{name}.

%prep
export LC_ALL=en_US.utf-8
%autosetup -p1

%build
%meson \
	-Dprofiler=false \
%ifarch %{arm}
	-Ddefault_driver=gles2 \
%else
	-Ddefault_driver=gl \
%endif	
	-Dremote_desktop=false

%meson_build

%install
%meson_install

# Create a dummy themes directory so that cinnamon settings will see
# the Adwaita fallback theme which has been removed from gnome-themes-standard
%__mkdir_p %{buildroot}/%{_datadir}/themes/Adwaita/metacity-1
cp %{SOURCE1} %{buildroot}/%{_datadir}/themes/Adwaita/metacity-1 
rm -f %{buildroot}/%{_bindir}/muffin

%find_lang %{name}

%files -f %{name}.lang
%doc NEWS
%license COPYING
%{_datadir}/themes/Adwaita/metacity-1/
%{_libexecdir}/muffin-restart-helper
%{_datadir}/applications/muffin.desktop

%files -n %{libname}
%{_libdir}/muffin/plugins/libdefault.so
%{_libdir}/libmuffin.so.%{major}{,.*}
%{_libdir}/{,muffin/}libmuffin-clutter-0.so*
%{_libdir}/{,muffin/}libmuffin-cogl-0.so*
%{_libdir}/{,muffin/}libmuffin-cogl-pango-0.so*
%{_libdir}/{,muffin/}libmuffin-cogl-path-0.so*

%files -n %{girname}
%{_libdir}/muffin/*{-,.}%{girmajor}.typelib

%files schemas
%{_datadir}/glib-2.0/schemas/org.cinnamon.muffin.gschema.xml
%{_datadir}/glib-2.0/schemas/org.cinnamon.muffin.*.gschema.xml

%files -n %{devname}
%{_includedir}/muffin/
%{_libdir}/libmuffin.so
%{_libdir}/muffin/*{-,.}0.gir
%{_libdir}/pkgconfig/*
%{_mandir}/man1/muffin*


%changelog
* Sun Dec 03 2023 joequant <joequant> 6.0.0-1.mga10
+ Revision: 2012737
- fix build requires
- add build requires
- update to 6.0.0

* Sat Sep 02 2023 joequant <joequant> 5.8.1-1.mga10
+ Revision: 1983605
- update to 5.8.1

* Mon Dec 05 2022 joequant <joequant> 5.6.1-1.mga9
+ Revision: 1917912
- update to 5.6.1

* Sat Nov 19 2022 joequant <joequant> 5.6.0-1.mga9
+ Revision: 1908953
- update to 5.6.0

* Sun Aug 07 2022 joequant <joequant> 5.4.5-1.mga9
+ Revision: 1875823
- update to 5.4.5

* Fri Jul 01 2022 joequant <joequant> 5.4.1-1.mga9
+ Revision: 1866973
- update to 5.4.1

* Sun Apr 03 2022 umeabot <umeabot> 5.2.0-3.mga9
+ Revision: 1841732
- Mageia 9 Mass Rebuild

* Mon Dec 13 2021 tv <tv> 5.2.0-2.mga9
+ Revision: 1761939
- Rebuild for new libwacom

* Wed Nov 24 2021 joequant <joequant> 5.2.0-1.mga9
+ Revision: 1758957
- update to 5.2.0

* Tue Aug 03 2021 joequant <joequant> 5.0.1-1.mga9
+ Revision: 1738851
- update to 5.0.1

* Wed Jun 02 2021 joequant <joequant> 5.0.0-1.mga9
+ Revision: 1729271
- update to 5.0.0

* Mon Feb 01 2021 wally <wally> 4.8.0-5.mga8
+ Revision: 1674381
- add private clutter/cogl devel requires excludes

* Mon Feb 01 2021 joequant <joequant> 4.8.0-4.mga8
+ Revision: 1674308
+ rebuild (emptylog)

* Tue Jan 12 2021 joequant <joequant> 4.8.0-3.mga8
+ Revision: 1671229
+ rebuild (emptylog)

* Sat Jan 09 2021 wally <wally> 4.8.0-2.mga8
+ Revision: 1670166
- add conflicts for files moved between pkgs in r1464961 and r1465048 (mga#28042)
- split out GSettings schemas
- filter out private clutter/cogl .so libraries from devel requires/provides
- move private clutter/cogl libs to lib pkg
- move mutter plugins to lib pkg
- move .gir files to devel pkg
- tag docs as such

* Tue Dec 08 2020 joequant <joequant> 4.8.0-1.mga8
+ Revision: 1654531
- update to 4.8.0

* Wed Sep 30 2020 joequant <joequant> 4.6.3-1.mga8
+ Revision: 1631330
- update to 4.6.3

* Sun Jun 28 2020 joequant <joequant> 4.6.2-1.mga8
+ Revision: 1599802
- update to 4.6.2

* Wed Jun 03 2020 joequant <joequant> 4.6.1-1.mga8
+ Revision: 1590164
- update to 4.6.1
- update to 4.6.1

* Sat May 16 2020 joequant <joequant> 4.6.0-1.mga8
+ Revision: 1584257
- update to 4.6.0
+ pterjan <pterjan>
- Remove usage of obsolete macros (https://github.com/rpm-software-management/rpm/issues/1211)

* Thu Feb 20 2020 umeabot <umeabot> 4.4.2-2.mga8
+ Revision: 1547355
- Mageia 8 Mass Rebuild

* Sat Feb 08 2020 joequant <joequant> 4.4.2-1.mga8
+ Revision: 1487967
- update to 4.4.2
+ wally <wally>
- replace deprecated %%configure2_5x

* Sat Dec 07 2019 joequant <joequant> 4.4.1-4.mga8
+ Revision: 1465048
- fix muffin gir

* Sat Dec 07 2019 joequant <joequant> 4.4.1-3.mga8
+ Revision: 1464982
- remove devel from so

* Sat Dec 07 2019 joequant <joequant> 4.4.1-2.mga8
+ Revision: 1464961
- split up muffin package

* Sat Dec 07 2019 joequant <joequant> 4.4.1-1.mga8
+ Revision: 1464874
- update to 4.4.1

* Thu Aug 22 2019 joequant <joequant> 4.2.2-2.mga8
+ Revision: 1431372
- update libdir

* Thu Aug 22 2019 joequant <joequant> 4.2.2-1.mga8
+ Revision: 1431367
- update to 4.2.2

* Fri Jul 05 2019 joequant <joequant> 4.2.0-1.mga8
+ Revision: 1418843
- update to 4.2

* Fri Apr 05 2019 joequant <joequant> 4.0.7-1.mga7
+ Revision: 1385893
- upgrade to 4.0.7

* Sun Jan 13 2019 joequant <joequant> 4.0.6-1.mga7
+ Revision: 1355857
- update to 4.0.6

* Mon Nov 26 2018 joequant <joequant> 4.0.2-1.mga7
+ Revision: 1335030
- upgrade to 4.0.2

* Mon Nov 05 2018 joequant <joequant> 4.0.0-1.mga7
+ Revision: 1328502
- fix utf-8
- add x libraries
- add pkgconfigs
- upgade to 4.0.0

* Mon Oct 01 2018 joequant <joequant> 3.8.3-2.mga7
+ Revision: 1313766
- upgrade to 3.8.3

* Sun Sep 23 2018 umeabot <umeabot> 3.8.2-2.mga7
+ Revision: 1299646
- Mageia 7 Mass Rebuild

* Sat Jun 30 2018 joequant <joequant> 3.8.2-1.mga7
+ Revision: 1240973
- update to 3.8.2

* Fri May 25 2018 joequant <joequant> 3.8.1-1.mga7
+ Revision: 1232201
- upgrade to 3.8.1

* Sat Apr 28 2018 joequant <joequant> 3.8.0-1.mga7
+ Revision: 1223153
- upgrade to 3.8.0
- upgrade to 3.8.0

* Wed Nov 01 2017 joequant <joequant> 3.6.0-1.mga7
+ Revision: 1175397
- update to 3.6.0

* Sat Aug 12 2017 joequant <joequant> 3.4.1-1.mga7
+ Revision: 1139967
- update to 3.4.1

* Mon Jul 17 2017 joequant <joequant> 3.4.0-1.mga7
+ Revision: 1123960
- upgrade to 3.4.0

* Mon Jan 23 2017 joequant <joequant> 3.2.2-1.mga6
+ Revision: 1083153
- upgrade to 3.2.2

* Sun May 22 2016 joequant <joequant> 3.0.4-1.mga6
+ Revision: 1017427
- upgrade to 3.0.4

* Sat May 07 2016 joequant <joequant> 3.0.0-5.mga6
+ Revision: 1010221
- add fedora patch

* Sat May 07 2016 joequant <joequant> 3.0.0-4.mga6
+ Revision: 1010193
- add suggestion by fedora to own the directory
- fix to add Adwaita to cinnamon settings

* Tue May 03 2016 joequant <joequant> 3.0.0-1.mga6
+ Revision: 1008830
- upgrade to 3.0.0

* Sat Mar 26 2016 joequant <joequant> 2.8.5-1.mga6
+ Revision: 995559
- upgrade to 2.8.5
+ umeabot <umeabot>
- Mageia 6 Mass Rebuild

* Wed Nov 18 2015 joequant <joequant> 2.8.3-1.mga6
+ Revision: 904005
- upgrade to 2.8.3

* Wed Oct 21 2015 joequant <joequant> 2.8.1-1.mga6
+ Revision: 893694
- upgrade to 2.8.1

* Fri Jun 26 2015 joequant <joequant> 2.6.1-1.mga6
+ Revision: 844296
- upgrade to 2.6

* Tue Jun 23 2015 joequant <joequant> 2.4.2-2.mga6
+ Revision: 841151
- add gnome 3.16 patches

* Thu Nov 27 2014 joequant <joequant> 2.4.2-1.mga5
+ Revision: 799548
- 2.4.2

* Sun Nov 23 2014 joequant <joequant> 2.4.1-1.mga5
+ Revision: 798399
- upgrade to 2.4

* Wed Oct 15 2014 umeabot <umeabot> 2.2.6-4.mga5
+ Revision: 746361
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 2.2.6-3.mga5
+ Revision: 727370
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 2.2.6-2.mga5
+ Revision: 682689
- Mageia 5 Mass Rebuild

* Sat Aug 30 2014 joequant <joequant> 2.2.6-1.mga5
+ Revision: 669424
- update to 2.2.6

* Tue Jun 10 2014 joequant <joequant> 2.2.5-1.mga5
+ Revision: 635388
- upgrade to 2.2.5

* Thu May 15 2014 joequant <joequant> 2.2.3-1.mga5
+ Revision: 622884
- put in version for cinnamon-session
- update to 2.2.3

* Fri Apr 18 2014 joequant <joequant> 2.2.1-1.mga5
+ Revision: 616809
- upgrade to 2.2

* Mon Feb 24 2014 pterjan <pterjan> 2.0.5-5.mga5
+ Revision: 596103
- Rebuild for new cogl

* Fri Feb 21 2014 joequant <joequant> 2.0.5-4.mga5
+ Revision: 595212
- add fedora patches
- put in fedora patches needed for new cogl
+ ovitters <ovitters>
- rebuild for new cogl

* Wed Jan 08 2014 joequant <joequant> 2.0.5-2.mga4
+ Revision: 565561
- push to core/release

* Wed Jan 01 2014 joequant <joequant> 2.0.5-1.mga4
+ Revision: 563803
- upgrade to 2.0.5

* Wed Oct 23 2013 joequant <joequant> 2.0.3-2.mga4
+ Revision: 546395
- upgrade to 2.0.3

* Mon Oct 21 2013 umeabot <umeabot> 2.0.1-2.mga4
+ Revision: 541269
- Mageia 4 Mass Rebuild

* Fri Oct 11 2013 joequant <joequant> 2.0.1-1.mga4
+ Revision: 495431
- update to 2.0.1

* Tue Oct 01 2013 joequant <joequant> 1.9.1-1.mga4
+ Revision: 490015
- upgrade to 1.9.1

* Mon Sep 02 2013 joequant <joequant> 1.8.3-0.4.gitc13a698.mga4
+ Revision: 474280
- update to latest git

* Fri Aug 23 2013 joequant <joequant> 1.8.3-0.3.git9611aa2.mga4
+ Revision: 470198
- update muffin

* Thu Aug 01 2013 dams <dams> 1.8.2-2.mga4
+ Revision: 462426
- rebuild for new cogl

* Sat Jun 01 2013 joequant <joequant> 1.8.2-1.mga4
+ Revision: 434269
- clean up spec file
- muffin 1.8.2
- upgrade cinnamon and muffin
- update to 1.7.4
- sync to latest 1.7 versions of cinnamon
- update to 1.7.1
- change API tag of Meta to avoid conflict with gnome-shell
  remove typelib(Meta) from spec
- imported package muffin


* Tue Jul 03 2012 Pedro <simplew8@gmail.com> 3.2.1-1
- first package (git SHA 930908f)
